#pragma semicolon 1

#include <sourcemod>
#include <steamtools>
#include <updater>

#define UPDATE_URL "http://bitbucket.org/gavvvr/sm-advanced-hl2dm-timeleft/raw/master/advhl2dmtimeleft.txt"

new Float:waitCmd0GameTime = 0.0;

new Handle:g_Cvar_ShowTimer = INVALID_HANDLE;

new Handle:g_Cvar_AllowWait = INVALID_HANDLE;
new Handle:g_Cvar_Fraglimit = INVALID_HANDLE;
new Handle:g_Cvar_Timelimit = INVALID_HANDLE;

public Plugin:myinfo =
{
	name = "Advanced HL2DM timeleft",
	author = "gavvvr, hl2dm.net",
	description = "Advanced timeleft for hl2dm match servers which does not fail because of mp_restartgame command",
	version = "0.1",
	url = "https://hl2dm.net"
};

public OnPluginStart()
{
    if (LibraryExists("updater"))
    {
        Updater_AddPlugin(UPDATE_URL);
    }

    RegConsoleCmd("timeleft", Command_Timeleft);

    g_Cvar_ShowTimer = CreateConVar("sm_timelefttimer", "1.0", "Defines if the ticking timer will be shown on the top of player's screen", _, true, 0.0, true, 1.0);

    g_Cvar_AllowWait = FindConVar("sv_allow_wait_command");
    HookConVarChange(g_Cvar_AllowWait, OnWaitCmdChanged);

    g_Cvar_Fraglimit = FindConVar("mp_fraglimit");
    g_Cvar_Timelimit = FindConVar("mp_timelimit");
}

public OnMapStart()
{
	waitCmd0GameTime = 0.0;
	if (GetConVarBool(g_Cvar_ShowTimer))
	{
		CreateTimer(1.0, Timer_Display, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:Timer_Display(Handle:timer) 
{
	new timeLeft = RoundToNearest(GetConVarFloat(g_Cvar_Timelimit)*60 - GetGameTime() + waitCmd0GameTime);
	new mins, secs;
	if (timeLeft > 0)
	{
		mins = timeLeft / 60;
		secs = timeLeft % 60;
		for (new i = 1; i <= MaxClients; i++)
		{
			if(IsClientInGame(i) && !IsFakeClient(i))
			{
				SetHudTextParams(-1.0, 0.01, 1.0, 255, 178, 50, 255, 1, 0.5, 0.1, 0.2);
				ShowHudText(i, -1, "%d:%02d", mins, secs);
			}
		}
	}
	return Plugin_Handled;
}

public OnLibraryAdded(const String:name[])
{
    if (StrEqual(name, "updater"))
    {
        Updater_AddPlugin(UPDATE_URL);
    }
}

public OnConfigsExecuted()
{
	DisablePlugin("basetriggers");
}

public Action:Command_Timeleft(client, args)
{
	if (!GetConVarBool(g_Cvar_Timelimit))
	{
		if (!GetConVarBool(g_Cvar_Fraglimit))
		{
			PrintToChat(client, "[SM] No timelimit for map");
			return Plugin_Handled;
		}
		PrintToChat(client, "[SM] Map will change after a player reaches %d frags", GetConVarInt(g_Cvar_Fraglimit));
		return Plugin_Handled;
	}
	new timeLeft = RoundToNearest(GetConVarFloat(g_Cvar_Timelimit)*60 - GetGameTime() + waitCmd0GameTime);
	new mins, secs;
	if (timeLeft > 0)
	{
		mins = timeLeft / 60;
		secs = timeLeft % 60;
		PrintToChat(client, "[SM] Time remaining for map: %d:%02d", mins, secs);
		return Plugin_Handled;
	}
	PrintToChat(client, "[SM] Time expired");
	return Plugin_Handled;
}

public OnWaitCmdChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (StrEqual(newValue, "0"))
	{
		waitCmd0GameTime = GetGameTime();
	}
}

bool:DisablePlugin(const String:file[])
{
	decl String:sNewPath[PLATFORM_MAX_PATH], String:sOldPath[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sNewPath, sizeof(sNewPath), "plugins/disabled/%s.smx", file);
	BuildPath(Path_SM, sOldPath, sizeof(sOldPath), "plugins/%s.smx", file);
	
	// If plugins/<file>.smx does not exist, ignore
	if(!FileExists(sOldPath))
	        return false;
	
	// If plugins/disabled/<file>.smx exists, delete it
	if(FileExists(sNewPath))
	        DeleteFile(sNewPath);
	
	// Unload plugins/<file>.smx and move it to plugins/disabled/<file>.smx
	ServerCommand("sm plugins unload %s", file);
	RenameFile(sNewPath, sOldPath);
	LogMessage("plugins/%s.smx was unloaded and moved to plugins/disabled/%s.smx", file, file);
	return true;
}