#include <sourcemod>
#include <sdktools_functions>
#include morecolors

static START_START = 3
static START_USED = 4
static CURRENT_START_STATE = 3
static Float:current_Start_Time = 0.0;
static CM_START = 5
static CM_USED = 6
static CURRENT_CM_STATE = 5
static Float:current_CM_Time = 0.0;
static String:mapName[100] = ""
static COINFLIP_START = 0
static COINFLIP_USERINPUT = 1
static String:currentCoinflipClient[100] = ""
static CURRENT_STATE = 0
new bool:bAdmin[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name = "Public Match Server",
	author = "<Jks>Maverick, Maxtasy",
	description = "Configurable Server Plugin for HL2DM Match Servers.",
	version = "1.7",
	url = "https://hl2dm.net"
};

public OnClientPostAdminCheck(client)  
{  	
	new Handle:authorisation_enabled = FindConVar("sm_authorisation_enabled")
	new bool:sm_authorisation_enabled = GetConVarBool(authorisation_enabled)
	if (sm_authorisation_enabled)
	{
		new flags = GetUserFlagBits(client);
		if ((flags & ADMFLAG_CONFIG) | (flags & ADMFLAG_ROOT))
		{
			bAdmin[client] = true;  
		}
	}
	else
	{
		bAdmin[client] = true;
	}
}

public OnClientDisconnect(client)
{
	bAdmin[client] = false;
}

public OnPluginStart()
{
	AutoExecConfig()
	CreateConVar("sm_teamplay_switchable", "1", "Enables the use of #.# teamplay")
	CreateConVar("sm_chat_command_prefix", "#.#", "Sets the chat command prefix.")
	CreateConVar("sm_authorisation_enabled","0", "Enables the Requirement of the Sourcemod Admin flag (Root or Config) for several Commands.")
	CreateConVar("sm_restart_enabled", "1", "Enables the use of #.# restart")
	CreateConVar("sm_cm_enabled","1", "Enables the use of #.# cm")
	CreateConVar("sm_start_enabled", "1", "Enables the use of #.# start")
	new Handle:authorisation_enabled = FindConVar("sm_authorisation_enabled")
	new bool:sm_authorisation_enabled = false
	sm_authorisation_enabled = GetConVarBool(authorisation_enabled)
	RegConsoleCmd("say", Command_Say);
	RegConsoleCmd("say_team", Command_Say);
	new index = GetMaxClients()
	for (new i = 1; i <= index; i++)
	{
		if(IsClientConnected(i))
		{
			if(IsClientAuthorized(i))
			{
				if(sm_authorisation_enabled)
				{
					new flags = GetUserFlagBits(i);  
					if ((flags & ADMFLAG_CONFIG) | (flags & ADMFLAG_ROOT))
					{
						bAdmin[i] = true;  
					}
				}
				else
				{
					bAdmin[i] = true;
				}
			}
		}
	}		
}

public Action:Command_Say(client, args)
{
	new String:clientName[100]
	new String:arg[200]
	new String:args[3][100]
	new String:argsSay[2][200]
	new String:splitter[1] = " "
	new Handle:chat_command_prefix = FindConVar("sm_chat_command_prefix")
	new String:admin_command_prefix[50] = "#.#"
	GetConVarString(chat_command_prefix,admin_command_prefix,sizeof(admin_command_prefix))
	new Handle:teamplay = FindConVar("mp_teamplay")
	new Handle:password = FindConVar("sv_password")
	new String:passwordString[100]
	new Handle:sm_teamplay_switchable = FindConVar("sm_teamplay_switchable")
	new Handle:sm_restart_enabled = FindConVar("sm_restart_enabled")
	new bool:restart_enabled = false
	new Handle:sm_cm_enabled = FindConVar("sm_cm_enabled")
	new bool:cm_enabled = false
	new Handle:sm_start_enabled = FindConVar("sm_start_enabled")
	new bool:start_enabled = false
	
	GetCmdArgString(arg, sizeof(arg))
	StripQuotes(arg)
	
	if(CURRENT_STATE == COINFLIP_USERINPUT)
	{
		new String:currentClient[100]
		GetClientAuthString(client,currentClient,sizeof(currentClient))
		new String:actual[20]
		new String:other[20]
		if(StrEqual(currentClient,currentCoinflipClient,true))
		{
			new randomInt = GetRandomInt(1,1000)
			
			
			if(randomInt <= 500)
			{
				actual = "heads"
				other  = "tails"
			}
			else 
			{
				actual = "tails"
				other = "heads"
			}
			
			if(StrEqual(arg,actual,false))
			{
				CPrintToChatAll("{aliceblue}Guess: {purple}%s {aliceblue}The Coin shows: {purple}%s",arg,actual)
				coinflipWinner(client)
				CURRENT_STATE = COINFLIP_START
				currentCoinflipClient = ""
			}
			else if (StrEqual(arg,other,false))
			{
				CPrintToChatAll("{aliceblue}Guess: {purple}%s {aliceblue}The Coin shows: {purple}%s",arg,actual)
				coinflipLoser(client)
				CURRENT_STATE = COINFLIP_START
				currentCoinflipClient = ""
			}
			else
			{
				CPrintToChat(client,"{aliceblue}Pick {purple}heads {aliceblue}or {purple}tails{aliceblue}.")
			}
			return Plugin_Handled;
			
		}
		else
		{
			if ((StrEqual(arg,actual,false)) || (StrEqual(arg,other,false)))
			{
				CPrintToChat(client,"{crimson}You can not flip the coin!")
				return Plugin_Handled;
			}
		}
	}
	
	
	ExplodeString(arg,splitter, args, 3, 100)
	
	if(StrEqual(args[0], admin_command_prefix, true))
	{
		new String:teamplay_switchable = GetConVarInt(sm_teamplay_switchable)
		restart_enabled = GetConVarBool(sm_restart_enabled)
		start_enabled = GetConVarBool(sm_start_enabled)
		cm_enabled = GetConVarBool(sm_cm_enabled)
		
		if(StrEqual(args[1], "pw", false) || StrEqual(args[1], "Password", false))
		{
			GetConVarString(password,passwordString,sizeof(passwordString))
			if(StrEqual(passwordString, "", true))
				CPrintToChat(client,"{aliceblue}Server has no Password. %s", passwordString);
			else
			CPrintToChat(client,"{aliceblue}Password: {purple}%s", passwordString);
		}
		
		else if(StrEqual(args[1], "teamplay", false))
		{
			if(teamplay_switchable == 1)
			{
				if(bAdmin[client] ==true)
				{
					new teamplayValue = GetConVarInt(teamplay)
					if((StrEqual(args[2], "0", false) || StrEqual(args[2], "off", false)) && teamplayValue == 1)
					{
						SetConVarBool(teamplay,false,false,true)
						CPrintToChat(client,"{purple}Deathmatch {aliceblue}activated after mapchange.  %s","");
					}
					else if((StrEqual(args[2], "1", false) || StrEqual(args[2], "on", false)) && teamplayValue == 0)
					{
						SetConVarBool(teamplay,true,false,true)
						CPrintToChat(client,"{purple}Team Deathmatch {aliceblue}activated after mapchange.  %s","");
					}
					else
					{
						CPrintToChat(client,"{aliceblue}Use {purple}#.# teamplay 1 {aliceblue}and {purple}0 {aliceblue}to switch Teamplay-Mode ON and OFF.")
					}
				}
				else
				{
					CPrintToChat(client,"{aliceblue}You are not allowed to switch Teamplay-Mode on this Server.")
				}
			}
			else
			{
				CPrintToChat(client,"{aliceblue}Switching Teamplay-Mode is not enabled on this Server.")
			}
		}
		
		else if(StrEqual(args[1], "coinflip", false))
		{
			if(GetClientTeam(client) == 1)
				CPrintToChat(client,"{aliceblue}You can not flip the coin in Spectate-Mode. Join the game to do so.")
			else
			{
				GetClientName(client, clientName, sizeof(clientName));
				CPrintToChatAll("{aliceblue}Player {purple}%s {aliceblue}has to flip the coin.",clientName)
				CPrintToChat(client,"{aliceblue}Pick {purple}heads {aliceblue}or {purple}tails{aliceblue}.")
				GetClientAuthString(client,currentCoinflipClient,sizeof(currentCoinflipClient))
				CURRENT_STATE = COINFLIP_USERINPUT
			}
		}
		
		else if(StrEqual(args[1], "restart", false))
		{
			if(restart_enabled)
			{
				if(bAdmin[client] == true)
				{
					InsertServerCommand("mp_restartgame 5 %s","");
					CPrintToChatAll("{aliceblue}Map will restart in 5 Seconds.")
					CreateTimer(4.0, SayRestart_One)
					return Plugin_Continue
				}
				else
				{
					CPrintToChat(client,"{aliceblue}You are not allowed to restart the game on this Server.")
				}
			}
			else
			{
				CPrintToChat(client,"{aliceblue}Restarting is not enabled on this Server.")
			}
		}
		
		else if(StrEqual(args[1], "cm", false))
		{
			if(cm_enabled == true)
			{
				if(bAdmin[client] == true)
				{
					
					if(CURRENT_CM_STATE == CM_USED)
					{
						new Float:currentTime2 = GetEngineTime()
						
						if((currentTime2 - current_CM_Time) <= 6)
						{
							CPrintToChat(client,"{aliceblue}Wait until the map has changed.");
							return Plugin_Handled;
						}
						else
						{
							CURRENT_CM_STATE = CM_START
							current_CM_Time = 0.0
							currentTime2 = 0.0
						}
					}
					new String:buildPath[100]
					BuildPath(Path_SM, buildPath, sizeof(buildPath), "configs/pms/pms_map_shortcuts.cfg");
					mapName = ""
					new Handle:kv = CreateKeyValues("Maps");
					FileToKeyValues(kv, buildPath);
					if (KvJumpToKey(kv, "Maps"))
						KvGetString(kv, args[2], mapName, 100);
					CloseHandle(kv);
					if(StrEqual(mapName, "", true) || !IsMapValid(mapName))
					{
						CPrintToChat(client,"{aliceblue}Map {purple}%s {aliceblue}is not available on this Server.",args[2]);
					}
					else
					{
						current_CM_Time = GetEngineTime()
						CURRENT_CM_STATE = CM_USED
						CPrintToChatAll("{aliceblue}Map will change to {purple}%s {aliceblue}in 5 seconds.",mapName)
						CreateTimer(5.0,changeMap)
						return Plugin_Continue
					}
				}
				
				else
				{
					CPrintToChat(client,"{aliceblue}You are not allowed to change the map on this Server.")
				}
			}
			
			else
			{
				CPrintToChat(client,"{aliceblue}Map-Changing is not enabled on this Server.")
			}
			
		}
		
		else if(StrEqual(args[1], "start", false))
		{
			if(start_enabled == true)
			{
				if(CURRENT_START_STATE == START_USED)
				{
					new Float:currentTime = GetEngineTime()
					
					if((currentTime - current_Start_Time) <= 60)
					{
						CPrintToChat(client,"{aliceblue}You need to wait 60 seconds between Match Starts.");
						return Plugin_Handled;
					}
					else
					{
						CURRENT_START_STATE = START_START
						current_Start_Time = 0.0
						currentTime = 0.0
					}
				}
				
				if(bAdmin[client] == true)
				{
					new String:buildPath[100]
					BuildPath(Path_SM, buildPath, sizeof(buildPath), "configs/pms/pms_config_shortcuts.cfg");
					new String:configName[100] = ""
					new Handle:kv = CreateKeyValues("Configs");
					FileToKeyValues(kv, buildPath);
					if (KvJumpToKey(kv, "Configs"))
						KvGetString(kv, args[2], configName, 100);
					CloseHandle(kv);
					if(StrEqual(configName, "", true))
					{
						CPrintToChat(client,"{aliceblue}Config not found! {purple}%s",args[2]);
					}
					else
					{
						current_Start_Time = GetEngineTime()
						CURRENT_START_STATE = START_USED
						new random = GetRandomInt(1111, 9999)
						IntToString(random,passwordString,20);
						InsertServerCommand("sv_password %s",passwordString);
						InsertServerCommand("tv_stoprecord");
						new String:time[100]
						new String:currentMap[100]
						new String:gametype[100]
						if(GetConVarInt(teamplay) == 1)
							gametype = "tdm"
						else
						gametype = "dm"
						FormatTime(time, 100, "%Y%m%d-%Hh%Mm%Ss");
						GetCurrentMap(currentMap, 100);
						InsertServerCommand("tv_record demos/%s-%s-%s%s", time, currentMap, gametype,".dem");
						InsertServerCommand("exec %s",configName);
						
						CPrintToChatAll("{aliceblue}Password was set to: {purple}%s",passwordString);
						return Plugin_Continue
					}
				}
				
				else
				{
					CPrintToChat(client,"{aliceblue}You are not allowed to start Matches on this Server.")
				}
				
			}
			
			else
			{
				CPrintToChat(client,"{aliceblue}Starting Matches is not enabled on this Server.")
			}
			
			
		}
		
		else if(StrEqual(args[1], "help", false))
		{
			if(teamplay_switchable == 1)
				CPrintToChat(client,"{aliceblue}%s teamplay 1 and 0 to switch Teamplay-Mode ON and OFF.", admin_command_prefix)
			if(start_enabled)	
				CPrintToChat(client,"{aliceblue}%s start <cfg> to start a Match.", admin_command_prefix)
			if(cm_enabled)
				CPrintToChat(client,"{aliceblue}%s cm <mapname> to change the Map.", admin_command_prefix)
			if(restart_enabled)
				CPrintToChat(client,"{aliceblue}%s restart to make a soft restart.", admin_command_prefix)
			CPrintToChat(client,"{aliceblue}%s password to see the current password.", admin_command_prefix)
			CPrintToChat(client,"{aliceblue}%s coinflip to let a random Player flip the coin.", admin_command_prefix)
		}	
		
		else if(StrEqual(args[1], "say", false))
			return Plugin_Continue
		
		else if(StrEqual(args[1], "say_team", false))
			return Plugin_Continue
		else
		{
			CPrintToChat(client,"{aliceblue}This command does not exist: {purple}%s",args[1])
		}
		
	}
	else
	{
	return Plugin_Continue
	}
	
	return Plugin_Handled;
	
}

public Action:SayRestart_One(Handle:timer)
{
	PrintCenterTextAll("%s", "Game will restart in 1 SECOND")
}

public Action:changeMap(Handle:timer)
{
	InsertServerCommand("changelevel %s",mapName);
}

public Action:coinflipWinner(client)
{
	new clientTeam = GetClientTeam(client);
	new index = GetMaxClients()
	for (new i = 1; i <= index; i++)
	{
		if(clientTeam == 2)
		{
			if(IsClientInGame(i) && GetClientTeam(i) == 2)
				CPrintToChat(i,"{green}You won the coinflip.")
			if(IsClientInGame(i) && GetClientTeam(i) == 3)
				CPrintToChat(i,"{crimson}You lost the coinflip.")
		}	
		else if(clientTeam == 3)
		{
			if(IsClientInGame(i) && GetClientTeam(i) == 3)
				CPrintToChat(i,"{green}You won the coinflip.")
			if(IsClientInGame(i) && GetClientTeam(i) == 2)
				CPrintToChat(i,"{crimson}You lost the coinflip.")
		}
		else if(clientTeam == 0)
		{
			if(IsClientInGame(i))
			{
				if(client == i)
					CPrintToChat(i,"{green}You won the coinflip.")
				else
					CPrintToChat(i,"{crimson}You lost the coinflip.")
			}
		}
	}
	
	
}

public Action:coinflipLoser(client)
{
	new clientTeam = GetClientTeam(client);
	new index = GetMaxClients()
	for (new i = 1; i <= index; i++)
	{
		if(clientTeam == 2)
		{
			if(IsClientInGame(i) && GetClientTeam(i) == 3)
				CPrintToChat(i,"{green}You won the coinflip.")
			if(IsClientInGame(i) && GetClientTeam(i) == 2)
				CPrintToChat(i,"{crimson}You lost the coinflip.")
		}	
		else if(clientTeam == 3)
		{
			if(IsClientInGame(i) && GetClientTeam(i) == 2)
				CPrintToChat(i,"{green}You won the coinflip.")
			if(IsClientInGame(i) && GetClientTeam(i) == 3)
				CPrintToChat(i,"{crimson}You lost the coinflip.")
		}
		else if(clientTeam == 0)
		{
			if(IsClientInGame(i))
			{
				if(client == i)
					CPrintToChat(i,"{crimson}You lost the coinflip.")
				else
					CPrintToChat(i,"{green}You won the coinflip.")
			}
		}
	}
}